#!/bin/bash
# gcheck.sh
# Andrew Davison, ad@fivedots.coe.psu.ac.th, Feb 2020

check()
# apply gcc and cppcheck to the supplied C file
{
  if [ ${1: -2} != ".c" ]; then
    echo "$1 is not a C file"
    return 1
  fi
  
  
  local name=${1%.*}
  echo "----- Compiling $1 to $name..."
  gcc -std=c99 @warns.txt -O3 -o "$name" "$1"
  
  # echo "  cppcheck..."
  cppcheck --quiet --enable=warning,style --std=c99 \
           --template=gcc  "$1"

  return 0
}   # end of check()


# ---------------- main --------------------


if [ "$#" -eq 0 ]; then
  echo "Usage: ./gcheck.sh <c file(s)>"
  exit 1
fi


for file in "$@"; do
#  echo $file
  check $file
done

